import 'dart:async';

import 'package:flutter/services.dart';

class Agoravoice {
  static const MethodChannel _channel = const MethodChannel('agoravoice');
  static const EventChannel _stream = const EventChannel('listener');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static init(String appId) async {
    await _channel.invokeMethod('init', <String, String>{
      'appId': appId,
    });
  }

  static join(String accessToken, String channel) async {
    await _channel.invokeMethod('join',
        <String, String>{'accessTokenUrl': accessToken, 'channel': channel});
  }

  static leave() async {
    await _channel.invokeMethod('leave');
  }

  static mute(bool mute) async {
    await _channel.invokeMethod('mute', <String, bool>{'mute': mute});
  }

  static speakerPhone(bool enable) async {
    await _channel.invokeMethod('speaker', <String, bool>{'enable': enable});
  }

  static dispose() async {
    await _channel.invokeMethod('dispose');
  }

  static Stream<dynamic> listener() {
    return _stream.receiveBroadcastStream();
  }
}
